> This page is for version v2 (default).
> For other versions, use one of these documentation indexes:
> - v2 (default): https://developers.clearpay.co.uk/v-2/llms.txt
> - v1: https://developers.clearpay.co.uk/v-1/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.clearpay.co.uk/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.clearpay.co.uk/_mcp/server.

# Update Payment by Order ID

PUT https://global-api-sandbox.afterpay.com/v2/payments/{orderId}
Content-Type: application/json

The Readme API Simulator includes form elements for both required and optional Body Params. If not populated with values, Readme will send empty strings to the Clearpay Online API. Any optional parameter that is validated against a Model will need to have all of its required sub-params populated with non-empty values.

Therefore, to avoid receiving unexpected "400" responses from Clearpay, please fill out all fields of the simulation form with valid values. This is particularly important for the amount and currency sub-params of the amount, taxAmount and shippingAmount params.

## Success Response (201)

Returns object containing the following attributes.

| Parameter           | Type                                          | Description                                                                                                                               |
| :------------------ | :-------------------------------------------- | :---------------------------------------------------------------------------------------------------------------------------------------- |
| id                  | string                                        | The unique Clearpay (merchant payment) payment Id                                                                                         |
| token               | string                                        | Checkout token to be used to complete consumer checkout and payment.                                                                      |
| status              | string                                        | "APPROVED" (update is only valid for successful orders)                                                                                   |
| created             | string (ISO-8601)                             | The payment creation time (ISO 8601 UTC/Zulu time).                                                                                       |
| originalAmount      | [Money object](/money-object)                 | Total amount for the order.                                                                                                               |
| openToCaptureAmount | [Money object](/money-object)                 | Total amount that can be captured for order.                                                                                              |
| paymentState        | string                                        | Available states:  "AUTH\_APPROVED",  "CAPTURED",  "VOIDED",  "EXPIRED",  "AUTH\_DECLINED",  "PARTIALLY\_CAPTURED",  "CAPTURE\_DECLINED"; |
| merchantReference   | string                                        | The merchant’s order id/reference that this payment corresponds to.                                                                       |
| refunds             | [Refund object](/refund-object)               | The refund details for merchant's order                                                                                                   |
| orderDetails        | [Order Details object](/order-details-object) | The order bound to the payment.                                                                                                           |
| events              | [Payment Event object](/payment-event-object) | Event list for for merchant's order.                                                                                                      |

Note\
This end point is for merchants that create a merchant side order id following the Clearpay order id creation.\
The merchant should call this immediately after the Clearpay order is created in order to properly update it with their order id so that it can be tracked.

## Errors

In addition to the [PUT/POST Errors](/put-post-errors) applicable to all PUT endpoints, the following errors are specific to Update Payment By PaymentId:

| HTTP Status Code   | errorCode   | Description                                      |
| :----------------- | :---------- | :----------------------------------------------- |
| **404**  Not Found | `not_found` | The Clearpay payment Id to update was not found. |

Reference: https://developers.clearpay.co.uk/api-reference/update-payment-by-order-id

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Path parameters

- `orderId` (string, required) — The Order ID to update

### Headers

- `Accept` (string, optional, default: application/json)

### Body (application/json)

This endpoint expects an object.

- `merchantReference` (string, required, default: new_merchant_order_id_1234) — The merchant’s new order id to replace with

## Response

### 200

200

## Errors

### 400 Bad Request Error

400

## Examples

**Request**

```json
{
  "merchantReference": "new_merchant_order_id_1234"
}
```

**Response**

```json
{}
```

**SDK Code**

```python
import requests

url = "https://global-api-sandbox.afterpay.com/v2/payments/orderId"

payload = { "merchantReference": "new_merchant_order_id_1234" }
headers = {
    "User-Agent": "User-Agent"
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers, auth=("<username>", "<password>"))

print(response.json())
```

```javascript
const url = 'https://global-api-sandbox.afterpay.com/v2/payments/orderId';
const credentials = btoa("<username>:<password>");

const options = {
  method: 'PUT',
  headers: {
    'User-Agent': 'User-Agent',
    Authorization: `Basic ${credentials}`,
    'Content-Type': 'application/json'
  },
  body: '{"merchantReference":"new_merchant_order_id_1234"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://global-api-sandbox.afterpay.com/v2/payments/orderId"

	payload := strings.NewReader("{\n  \"merchantReference\": \"new_merchant_order_id_1234\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("User-Agent", "User-Agent")
	req.SetBasicAuth("<username>", "<password>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://global-api-sandbox.afterpay.com/v2/payments/orderId")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["User-Agent"] = 'User-Agent'
request.basic_auth("<username>", "<password>")
request["Content-Type"] = 'application/json'
request.body = "{\n  \"merchantReference\": \"new_merchant_order_id_1234\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://global-api-sandbox.afterpay.com/v2/payments/orderId")
  .header("User-Agent", "User-Agent")
  .basicAuth("<username>", "<password>")
  .header("Content-Type", "application/json")
  .body("{\n  \"merchantReference\": \"new_merchant_order_id_1234\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://global-api-sandbox.afterpay.com/v2/payments/orderId', [
  'body' => '{
  "merchantReference": "new_merchant_order_id_1234"
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'User-Agent' => 'User-Agent',
  ],
    'auth' => ['<username>', '<password>'],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://global-api-sandbox.afterpay.com/v2/payments/orderId");
client.Authenticator = new HttpBasicAuthenticator("<username>", "<password>");
var request = new RestRequest(Method.PUT);
request.AddHeader("User-Agent", "User-Agent");

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"merchantReference\": \"new_merchant_order_id_1234\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let credentials = Data("<username>:<password>".utf8).base64EncodedString()

let headers = [
  "User-Agent": "User-Agent",
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]
let parameters = ["merchantReference": "new_merchant_order_id_1234"] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://global-api-sandbox.afterpay.com/v2/payments/orderId")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```